/* A Bison parser, made from parser.yxx
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	IDENTIFIER	257
# define	SYMBOL	258
# define	TYPE_FLOAT	259
# define	TYPE_POINT	260
# define	TYPE_STRING	261
# define	TYPE_COLOR	262
# define	TYPE_NORMAL	263
# define	TYPE_VECTOR	264
# define	TYPE_VOID	265
# define	TYPE_MATRIX	266
# define	TYPE_UNIFORM	267
# define	TYPE_VARYING	268
# define	SHADER_TYPE_SURFACE	269
# define	SHADER_TYPE_VOLUME	270
# define	SHADER_TYPE_IMAGER	271
# define	SHADER_TYPE_TRANSFORMATION	272
# define	SHADER_TYPE_DISPLACEMENT	273
# define	SHADER_TYPE_LIGHT	274
# define	SHADER_TYPE_ATMOSPHERE	275
# define	ATTRIBUTE	276
# define	OPTION	277
# define	RENDERERINFO	278
# define	INCIDENT	279
# define	OPPOSITE	280
# define	LIGHTSOURCE	281
# define	EXTERN	282
# define	TEXTUREINFO	283
# define	OUTPUT	284
# define	IF	285
# define	ELSE	286
# define	WHILE	287
# define	FOR	288
# define	CONTINUE	289
# define	BREAK	290
# define	RETURN	291
# define	ILLUMINATE	292
# define	ILLUMINANCE	293
# define	SOLAR	294
# define	TEXTUREMAP	295
# define	ENVIRONMENT	296
# define	BUMP	297
# define	SHADOW	298
# define	OCCLUSION	299
# define	SETXCOMP	300
# define	SETYCOMP	301
# define	SETZCOMP	302
# define	SETCOMP	303
# define	ADD_ASSIGN	304
# define	SUB_ASSIGN	305
# define	MUL_ASSIGN	306
# define	DIV_ASSIGN	307
# define	OR_OP	308
# define	AND_OP	309
# define	GE_OP	310
# define	LE_OP	311
# define	EQ_OP	312
# define	NE_OP	313
# define	NEG	314
# define	FLOAT_CONSTANT	315
# define	STRING_LITERAL	316

#line 5 "parser.yxx"

#ifdef	WIN32
#include <malloc.h>
#pragma warning(disable : 4786)
#include <cstdio>
#include <memory>
namespace std
{ using ::size_t; 
  using ::malloc;
  using ::free;
}
#endif

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cassert>

#include	"parsenode.h"
#include	"logging.h"

# define YYMAXDEPTH 100000
# define YYINITDEPTH  2000

using namespace Aqsis;


namespace Aqsis
{

extern CqString ParseStreamName;
extern std::ostream* ParseErrorStream;
extern TqInt ParseLineNumber;
extern TqBool ParseSucceeded;
CqParseNode*	ParseTreePointer;
std::vector<CqString>	ParseNameSpaceStack;
std::vector<TqInt>		FunctionReturnCountStack;
EqShaderType gShaderType;

TqBool	FindVariable(const char* name, SqVarRef& ref);
TqBool	FindFunction(const char* name, std::vector<SqFuncRef>& Ref);
CqString strNameSpace();
void	TypeCheck();
void	Optimise();
void	InitStandardNamespace();
void	ProcessShaderArguments( CqParseNode* pArgs );

}


#line 59 "parser.yxx"
#ifndef YYSTYPE
typedef union{
	CqParseNode*	m_pParseNode;
	TqInt			m_VarType;
	EqShaderType	m_ShaderType;
	TqFloat			m_FloatConst;
	CqString*	m_Identifier;
	struct{
		SqVarRef		VarRef;
		SqFuncRef		FuncRef;
		TqInt				eType;
	}				m_pSymbol;
	struct{
		TqInt				Type;
		CqString*	Space;
	}				m_TypeAndSpace;
	EqCommType		m_CommType;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#line 77 "parser.yxx"

extern TqInt yylex();
static void yyerror(const CqString Message);
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		372
#define	YYFLAG		-32768
#define	YYNTBASE	83

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 316 ? yytranslate[x] : 128)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,     2,     2,     2,
      73,    74,    69,    65,    80,    66,    70,    68,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    79,
      61,    50,    59,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,     2,    82,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    51,    52,    53,    54,    57,    58,
      60,    62,    63,    64,    71,    75,    76
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     5,     7,     9,    18,    27,    35,    43,
      50,    56,    60,    63,    67,    70,    72,    74,    76,    78,
      80,    82,    84,    88,    91,    94,    98,   101,   105,   108,
     110,   112,   116,   119,   121,   126,   132,   136,   139,   141,
     146,   152,   156,   159,   164,   166,   170,   172,   174,   176,
     178,   180,   182,   184,   186,   188,   190,   193,   195,   198,
     200,   203,   205,   208,   210,   213,   215,   217,   219,   222,
     225,   228,   231,   234,   238,   241,   243,   246,   248,   252,
     255,   257,   261,   267,   271,   281,   286,   294,   300,   310,
     316,   324,   334,   346,   349,   351,   353,   355,   357,   361,
     365,   369,   373,   377,   381,   384,   386,   392,   395,   397,
     399,   401,   406,   408,   410,   412,   414,   416,   420,   428,
     462,   464,   466,   468,   470,   472,   474,   478,   482,   486,
     490,   493,   497,   501,   505,   509,   513,   520,   527,   534,
     541,   548,   553,   557,   562,   566,   568,   572,   579,   585,
     591,   596,   598,   600,   602,   604,   606,   608,   610,   614,
     617,   621,   623,   625,   627,   629,   631,   633,   635,   637,
     639,   641,   643,   650
};
static const short yyrhs[] =
{
      84,     0,    83,    84,     0,    85,     0,    86,     0,    88,
       3,    73,    89,    74,    77,   106,    78,     0,    88,     4,
      73,    89,    74,    77,   106,    78,     0,    88,     3,    73,
      74,    77,   106,    78,     0,    88,     4,    73,    74,    77,
     106,    78,     0,    87,    89,    74,    77,   106,    78,     0,
      87,    74,    77,   106,    78,     0,    92,     3,    73,     0,
       3,    73,     0,    92,     4,    73,     0,     4,    73,     0,
      20,     0,    15,     0,    16,     0,    19,     0,    18,     0,
      17,     0,    90,     0,    89,    79,    90,     0,    89,    79,
       0,    92,    93,     0,    30,    92,    93,     0,    92,    93,
       0,    28,    92,    93,     0,    98,    99,     0,    99,     0,
      94,     0,    93,    80,    94,     0,     3,    95,     0,     3,
       0,     3,    81,   125,    82,     0,     3,    81,   125,    82,
      96,     0,     3,    81,    82,     0,     4,    95,     0,     4,
       0,     4,    81,   125,    82,     0,     4,    81,   125,    82,
      96,     0,     4,    81,    82,     0,    50,   111,     0,    50,
      77,    97,    78,     0,   111,     0,    97,    80,   111,     0,
      14,     0,    13,     0,     5,     0,     7,     0,    11,     0,
     100,     0,   101,     0,   102,     0,   103,     0,   104,     0,
       6,   105,     0,     6,     0,     8,   105,     0,     8,     0,
      10,   105,     0,    10,     0,     9,   105,     0,     9,     0,
      12,   105,     0,    12,     0,    76,     0,   107,     0,   106,
     107,     0,   116,    79,     0,   117,    79,     0,   118,    79,
       0,   127,    79,     0,    37,   111,    79,     0,   109,    79,
       0,   108,     0,    91,    79,     0,    86,     0,    77,   106,
      78,     0,    77,    78,     0,    79,     0,    31,   115,   107,
       0,    31,   115,   107,    32,   107,     0,    33,   115,   107,
       0,    34,    73,   111,    79,   115,    79,   111,    74,   107,
       0,    40,    73,    74,   107,     0,    40,    73,   111,    80,
     111,    74,   107,     0,    38,    73,   111,    74,   107,     0,
      38,    73,   111,    80,   111,    80,   111,    74,   107,     0,
      39,    73,   111,    74,   107,     0,    39,    73,   111,    80,
     111,    74,   107,     0,    39,    73,   111,    80,   111,    80,
     111,    74,   107,     0,    39,    73,   111,    80,   111,    80,
     111,    80,   111,    74,   107,     0,   110,   125,     0,   110,
       0,    36,     0,    35,     0,   113,     0,   111,    70,   111,
       0,   111,    68,   111,     0,   111,    69,   111,     0,   111,
      67,   111,     0,   111,    65,   111,     0,   111,    66,   111,
       0,    66,   111,     0,   112,     0,   115,    55,   111,    56,
     111,     0,    99,   111,     0,   125,     0,   120,     0,     4,
       0,     4,    81,   111,    82,     0,    76,     0,   117,     0,
     118,     0,   127,     0,   116,     0,    73,   111,    74,     0,
      73,   111,    80,   111,    80,   111,    74,     0,    73,   111,
      80,   111,    80,   111,    80,   111,    80,   111,    80,   111,
      80,   111,    80,   111,    80,   111,    80,   111,    80,   111,
      80,   111,    80,   111,    80,   111,    80,   111,    80,   111,
      74,     0,    59,     0,    60,     0,    61,     0,    62,     0,
      63,     0,    64,     0,    73,   115,    74,     0,   111,   114,
     111,     0,   115,    58,   115,     0,   115,    57,   115,     0,
      72,   115,     0,     4,    50,   111,     0,     4,    51,   111,
       0,     4,    52,   111,     0,     4,    53,   111,     0,     4,
      54,   111,     0,     4,    81,   111,    82,    50,   111,     0,
       4,    81,   111,    82,    51,   111,     0,     4,    81,   111,
      82,    52,   111,     0,     4,    81,   111,    82,    53,   111,
       0,     4,    81,   111,    82,    54,   111,     0,     4,    73,
     119,    74,     0,     4,    73,    74,     0,     3,    73,   119,
      74,     0,     3,    73,    74,     0,   111,     0,   119,    80,
     111,     0,   121,    73,   122,   123,   124,    74,     0,   121,
      73,   122,   124,    74,     0,   121,    73,   122,   123,    74,
       0,   121,    73,   122,    74,     0,    41,     0,    42,     0,
      43,     0,    44,     0,    45,     0,     4,     0,    76,     0,
      81,   111,    82,     0,    80,   111,     0,   124,    80,   111,
       0,    75,     0,    21,     0,    19,     0,    27,     0,    15,
       0,    22,     0,    23,     0,    24,     0,    25,     0,    26,
       0,    29,     0,   126,    73,   111,    80,     4,    74,     0,
     126,    73,   111,    80,   111,    80,     4,    74,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   165,   166,   171,   172,   176,   189,   205,   212,   225,
     264,   287,   295,   303,   316,   332,   335,   338,   341,   344,
     347,   353,   366,   377,   381,   452,   528,   603,   649,   653,
     657,   663,   671,   680,   687,   694,   703,   710,   724,   734,
     744,   756,   769,   775,   790,   796,   804,   805,   809,   813,
     817,   821,   822,   823,   824,   825,   829,   833,   840,   844,
     851,   855,   862,   866,   873,   877,   884,   888,   894,   902,
     903,   911,   919,   924,   933,   934,   935,   961,   962,   963,
     964,   965,   973,   987,   994,  1009,  1015,  1029,  1038,  1054,
    1067,  1081,  1098,  1119,  1120,  1124,  1128,  1136,  1137,  1148,
    1159,  1170,  1181,  1192,  1203,  1213,  1214,  1235,  1281,  1285,
    1286,  1290,  1295,  1299,  1300,  1301,  1302,  1303,  1306,  1314,
    1338,  1339,  1340,  1341,  1342,  1343,  1347,  1350,  1357,  1364,
    1371,  1379,  1385,  1399,  1413,  1427,  1441,  1448,  1466,  1484,
    1502,  1523,  1533,  1544,  1567,  1584,  1590,  1598,  1612,  1626,
    1632,  1641,  1647,  1653,  1659,  1665,  1674,  1678,  1685,  1689,
    1695,  1704,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,
    1717,  1718,  1723,  1744
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "IDENTIFIER", "SYMBOL", "TYPE_FLOAT", 
  "TYPE_POINT", "TYPE_STRING", "TYPE_COLOR", "TYPE_NORMAL", "TYPE_VECTOR", 
  "TYPE_VOID", "TYPE_MATRIX", "TYPE_UNIFORM", "TYPE_VARYING", 
  "SHADER_TYPE_SURFACE", "SHADER_TYPE_VOLUME", "SHADER_TYPE_IMAGER", 
  "SHADER_TYPE_TRANSFORMATION", "SHADER_TYPE_DISPLACEMENT", 
  "SHADER_TYPE_LIGHT", "SHADER_TYPE_ATMOSPHERE", "ATTRIBUTE", "OPTION", 
  "RENDERERINFO", "INCIDENT", "OPPOSITE", "LIGHTSOURCE", "EXTERN", 
  "TEXTUREINFO", "OUTPUT", "IF", "ELSE", "WHILE", "FOR", "CONTINUE", 
  "BREAK", "RETURN", "ILLUMINATE", "ILLUMINANCE", "SOLAR", "TEXTUREMAP", 
  "ENVIRONMENT", "BUMP", "SHADOW", "OCCLUSION", "SETXCOMP", "SETYCOMP", 
  "SETZCOMP", "SETCOMP", "'='", "ADD_ASSIGN", "SUB_ASSIGN", "MUL_ASSIGN", 
  "DIV_ASSIGN", "'?'", "':'", "OR_OP", "AND_OP", "'>'", "GE_OP", "'<'", 
  "LE_OP", "EQ_OP", "NE_OP", "'+'", "'-'", "'^'", "'/'", "'*'", "'.'", 
  "NEG", "'!'", "'('", "')'", "FLOAT_CONSTANT", "STRING_LITERAL", "'{'", 
  "'}'", "';'", "','", "'['", "']'", "file", "definitions", 
  "shader_definition", "function_definition", "function_declaration", 
  "shader_type", "formals", "formal_variable_definitions", 
  "variable_definitions", "typespec", "def_expressions", "def_expression", 
  "def_init", "def_array_initialisers", "array_initialisers", "detail", 
  "type", "pspace", "cspace", "vspace", "nspace", "mspace", "spacetype", 
  "statements", "statement", "loop_control", "loop_modstmt", "loop_mod", 
  "expression", "cast_expr", "primary", "relational_operator", "relation", 
  "assignexpression", "procedurecall", "unresolvedcall", "proc_arguments", 
  "texture", "texture_type", "texture_filename", "channel", 
  "texture_arguments", "number", "comm_type", "comm_function", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    83,    83,    84,    84,    85,    85,    85,    85,    86,
      86,    87,    87,    87,    87,    88,    88,    88,    88,    88,
      88,    89,    89,    89,    90,    90,    91,    91,    92,    92,
      93,    93,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    95,    96,    97,    97,    98,    98,    99,    99,
      99,    99,    99,    99,    99,    99,   100,   100,   101,   101,
     102,   102,   103,   103,   104,   104,   105,   106,   106,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   109,   109,   110,   110,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   112,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     114,   114,   114,   114,   114,   114,   115,   115,   115,   115,
     115,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   117,   117,   118,   118,   119,   119,   120,   120,   120,
     120,   121,   121,   121,   121,   121,   122,   122,   123,   124,
     124,   125,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   127,   127
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     1,     1,     8,     8,     7,     7,     6,
       5,     3,     2,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     2,     3,     2,     3,     2,     1,
       1,     3,     2,     1,     4,     5,     3,     2,     1,     4,
       5,     3,     2,     4,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     1,     1,     2,     2,
       2,     2,     2,     3,     2,     1,     2,     1,     3,     2,
       1,     3,     5,     3,     9,     4,     7,     5,     9,     5,
       7,     9,    11,     2,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     2,     1,     5,     2,     1,     1,
       1,     4,     1,     1,     1,     1,     1,     3,     7,    33,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     6,     6,     6,     6,
       6,     4,     3,     4,     3,     1,     3,     6,     5,     5,
       4,     1,     1,     1,     1,     1,     1,     1,     3,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     6,     8
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     0,     0,    48,    57,    49,    59,    63,    61,    50,
      65,    47,    46,    16,    17,    20,    19,    18,    15,     0,
       1,     3,     4,     0,     0,     0,     0,    29,    51,    52,
      53,    54,    55,    12,    14,    66,    56,    58,    62,    60,
      64,     2,     0,     0,     0,    21,     0,     0,     0,     0,
       0,    28,     0,     0,     0,    23,    33,    38,    24,    30,
       0,     0,    11,    13,    25,     0,     0,   165,   163,   162,
     166,   167,   168,   169,   170,   164,     0,   171,     0,     0,
       0,    96,    95,     0,     0,     0,     0,     0,    80,    77,
       0,     0,     0,    67,    75,     0,    94,     0,     0,     0,
       0,     0,     0,    22,     0,     0,    32,     0,    37,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      14,     0,     0,     0,   110,   151,   152,   153,   154,   155,
       0,     0,     0,   161,   112,     0,     0,   105,    97,     0,
     116,   113,   114,   109,     0,   108,   115,     0,     0,     0,
       0,     0,     0,     0,    79,     0,    76,    33,    38,    26,
      10,    68,    74,    93,    69,    70,    71,     0,    72,     0,
      42,    36,     0,    41,     0,    31,     0,     0,     0,     0,
     144,   145,     0,   131,   132,   133,   134,   135,   142,     0,
       0,    27,     0,     0,     0,   104,   130,     0,     0,   107,
     120,   121,   122,   123,   124,   125,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    81,     0,    83,     0,
      73,     0,     0,     0,     0,    78,     0,     9,    34,    39,
       0,     0,     0,     0,   143,     0,   141,     0,     0,   117,
       0,   126,   102,   103,   101,    99,   100,    98,   127,     0,
     129,   128,     0,   156,   157,     0,     0,     0,     0,     0,
       0,    85,     0,     0,     0,    35,    40,     7,     0,     8,
       0,   146,     0,     0,     0,     0,     0,   111,     0,     0,
      82,   150,     0,     0,     0,     0,     0,    87,     0,    89,
       0,     0,   110,     0,     0,     5,     6,   136,   137,   138,
     139,   140,     0,   106,   159,     0,   149,     0,   148,     0,
       0,     0,     0,     0,     0,   172,     0,     0,    44,     0,
     158,   147,   160,     0,     0,    90,     0,    86,     0,    43,
       0,   118,     0,     0,     0,     0,     0,   173,    45,     0,
      84,    88,    91,     0,     0,     0,     0,    92,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     119,     0,     0
};

static const short yydefgoto[] =
{
      19,    20,    21,    89,    23,    24,    44,    45,    90,    91,
      58,    59,   106,   265,   317,    26,   135,    28,    29,    30,
      31,    32,    36,    92,    93,    94,    95,    96,   136,   137,
     138,   212,   150,   140,   141,   142,   182,   143,   144,   255,
     284,   285,   145,   100,   146
};

static const short yypact[] =
{
    2010,   -49,   -16,-32768,   -56,-32768,   -56,   -56,   -56,-32768,
     -56,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1950,
  -32768,-32768,-32768,   179,    63,   145,   156,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   495,   -44,   -40,-32768,   155,    25,    30,    51,
      55,-32768,   155,  1343,    59,   442,   -37,   -29,   -32,-32768,
     266,   515,-32768,-32768,   -32,    71,    56,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   495,-32768,  1604,  1604,
      73,-32768,-32768,  1604,    84,   123,   125,   855,-32768,-32768,
       2,   191,   916,-32768,-32768,    14,   124,   121,   131,   132,
     129,   133,  1343,-32768,  1604,   -28,-32768,   -26,-32768,   155,
     126,     4,   127,    16,  1604,  1604,  1604,  1604,  1604,  1604,
    1604,  1604,   155,   141,    62,-32768,-32768,-32768,-32768,-32768,
    1604,  1604,  1604,-32768,-32768,  1604,  2064,-32768,-32768,   778,
  -32768,-32768,-32768,-32768,   142,-32768,-32768,   778,  1604,  1912,
      64,  1604,  1604,  1382,-32768,   977,-32768,   -41,   -38,   -32,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,  1604,-32768,  1038,
    2064,-32768,   134,-32768,   136,-32768,  1343,   143,  1343,   144,
  -32768,  2064,     5,  2064,  2064,  2064,  2064,  2064,-32768,    17,
     518,   -32,  1456,  1530,  1604,-32768,-32768,   683,    15,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,  1604,  1604,  1604,  1604,
    1604,  1604,  1604,  1604,  1604,  1604,   190,    -1,-32768,  1933,
  -32768,   837,   898,  1343,  1142,-32768,  1203,-32768,   174,   174,
    1099,  1343,  1160,  1343,-32768,  1604,-32768,    80,   545,-32768,
    1604,-32768,   170,   170,    83,   158,   158,-32768,  2064,  2052,
     168,-32768,  1343,-32768,-32768,   -52,  1604,  1343,  1604,  1343,
    1604,-32768,  1604,  1678,   148,-32768,-32768,-32768,  1221,-32768,
    1282,  2064,  1604,  1604,  1604,  1604,  1604,    80,  1264,  1604,
  -32768,-32768,  1604,  1604,    20,    43,     7,-32768,  1369,-32768,
     959,  1972,   -36,  1443,  1604,-32768,-32768,  2064,  2064,  2064,
    2064,  2064,  1604,  2064,  2064,   620,-32768,    46,-32768,  1604,
    1604,  1604,  1343,  1604,  1343,-32768,   225,    60,  2064,  1020,
  -32768,-32768,  2064,  1988,  2004,-32768,  1081,-32768,   161,-32768,
    1604,-32768,  1604,  1343,  1343,  1343,  1604,-32768,  2064,  1517,
  -32768,-32768,-32768,  2020,  1604,  1343,  1591,-32768,  1604,  1665,
    1604,  1696,  1604,  1718,  1604,  1740,  1604,  1762,  1604,  1784,
    1604,  1806,  1604,  1828,  1604,  1850,  1604,  1872,  1604,  2036,
  -32768,   242,-32768
};

static const short yypgoto[] =
{
  -32768,   224,-32768,    11,-32768,-32768,   110,   189,-32768,     8,
     -45,   138,   -53,    19,-32768,-32768,     0,-32768,-32768,-32768,
  -32768,-32768,   167,   -77,   509,-32768,-32768,-32768,   363,-32768,
  -32768,-32768,   -73,   -51,    58,   154,  -119,-32768,-32768,-32768,
  -32768,   -39,   -25,-32768,   205
};


#define	YYLAST		2134


static const short yytable[] =
{
      27,   189,    97,   253,   108,   139,   147,    64,    25,   104,
     155,    22,   104,   104,   115,   116,   117,   118,   119,    27,
      35,   104,   281,    27,    33,   169,    51,    25,   282,   283,
      22,    46,    62,    53,    54,    63,    97,   193,   315,    55,
     105,    97,    27,   107,   105,   194,   159,   133,   109,   133,
      52,    97,   107,    27,   171,    27,   173,    34,   196,   198,
      27,    27,   213,    46,   214,   215,    47,    48,    46,    46,
     213,   163,   214,   215,   189,   254,    27,   191,   177,   234,
     172,   156,   174,    55,   122,   235,   310,    27,    97,   241,
     179,   236,    27,   162,   306,    55,    97,   235,    60,   230,
     282,   232,    27,    61,    97,   108,   115,   116,   117,   118,
     119,    98,   115,   116,   117,   118,   119,   308,    97,   213,
     321,   214,   215,   309,    62,    97,   309,    97,    63,   120,
     272,   273,   274,   275,   276,   193,   102,   121,   329,    27,
     330,   250,   251,   194,   114,    98,   148,    27,    49,    50,
      98,   209,   210,   211,   268,    27,   270,   151,    56,    57,
      98,     3,     4,     5,     6,     7,     8,     9,    10,    27,
     111,   113,    97,    37,    38,    39,    27,    40,    27,    97,
      97,    97,    97,   286,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,   157,   158,   152,    98,   153,   133,
     164,    97,   167,   176,   178,    98,    97,    99,    97,    42,
     165,   166,   168,    98,   192,   217,   228,    97,   229,    97,
     231,   233,   252,    27,   264,   294,   215,    98,   211,   328,
      27,    27,    27,    27,    98,   337,    98,   208,   209,   210,
     211,    99,   372,    41,   103,   307,    99,   175,   266,     0,
       0,     0,    27,    43,     0,     0,    99,    27,   101,    27,
       0,    97,     0,    97,     0,     0,     0,     0,    27,     0,
      27,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    98,    97,    97,    97,     0,     0,     0,    98,    98,
      98,    98,   101,    99,    97,     0,    42,   101,     0,     0,
       0,    99,     0,     0,     0,     0,     0,   101,     0,    99,
      98,     0,    27,     0,    27,    98,     0,    98,     0,     0,
       0,     0,     0,    99,     0,     0,    98,     0,    98,     0,
      99,     0,    99,    27,    27,    27,     0,     0,     0,     0,
     110,     0,     0,     0,   101,    27,     0,     0,     0,     0,
       0,     0,   101,     0,     0,     0,     0,     0,     0,     0,
     101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,     0,    98,     0,   101,     0,     0,    99,     0,     0,
       0,   101,     0,   101,    99,    99,    99,    99,     0,     0,
       0,    98,    98,    98,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,     0,     0,    99,     0,     0,     0,
       0,    99,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,    99,     0,    99,     0,     0,     0,   101,     0,
       0,     0,     0,     0,     0,   101,   101,   101,   101,     0,
       0,     0,     0,     0,     0,     0,   149,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,   101,     0,     0,
       0,     0,   101,     0,   101,     0,    99,   170,    99,     0,
       0,     0,    42,   101,     0,   101,     0,   181,   183,   184,
     185,   186,   187,   181,   190,     0,     0,    99,    99,    99,
       0,     0,     0,   195,     0,   197,     0,     0,   199,    99,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
       0,   219,     0,     0,   221,   222,   224,   101,     0,   101,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     226,     0,     0,     0,     0,     0,     0,     0,   101,   101,
     101,     0,     0,     0,     0,    42,     0,     0,     0,     0,
     101,     0,     0,     0,     0,   181,   181,   238,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   242,
     243,   244,   245,   246,   247,   248,   249,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   112,
       0,     0,     0,     0,     0,     0,     0,     0,   271,     0,
     237,   161,     0,   278,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,     0,     0,     0,     0,
       0,   288,     0,   290,     0,   291,   293,   277,     0,     0,
       0,     0,     0,     0,     0,   297,   298,   299,   300,   301,
       0,     0,   303,     0,     0,   304,   305,     0,   216,     0,
       0,     0,     0,     0,     0,     0,   218,   318,     0,     0,
       0,     0,     0,     0,   161,   319,     0,     0,     0,     0,
       0,     0,   322,   323,   324,     0,   326,     0,   161,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,   338,     0,   339,     0,     0,     0,   343,
       0,     0,   320,     0,     0,     0,     0,   346,     0,     0,
       0,   349,     0,   351,     0,   353,     0,   355,     0,   357,
       0,   359,     0,   361,     0,   363,     0,   365,     0,   367,
       0,   369,   261,     0,     0,     0,     0,     0,     0,   161,
       0,   161,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,     0,     0,     0,   239,     0,     0,
       0,   280,     0,   240,     0,     0,   287,     0,   289,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,   161,
       0,    65,    66,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    67,     0,     0,     0,    68,     0,    69,
      70,    71,    72,    73,    74,    75,    76,    77,     0,    78,
       0,    79,    80,    81,    82,    83,    84,    85,    86,     0,
       0,   325,     0,   327,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   213,     0,   214,   215,     0,     0,     0,
       0,     0,   340,   341,   342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   347,    87,     0,    88,    65,    66,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      67,     0,     0,     0,    68,     0,    69,    70,    71,    72,
      73,    74,    75,    76,    77,     0,    78,     0,    79,    80,
      81,    82,    83,    84,    85,    86,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,     0,     0,
       0,   257,     0,     0,     0,     0,     0,   258,     0,    65,
      66,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    67,    87,   154,    88,    68,     0,    69,    70,    71,
      72,    73,    74,    75,    76,    77,     0,    78,     0,    79,
      80,    81,    82,    83,    84,    85,    86,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
       0,     0,   259,     0,     0,     0,     0,     0,   260,     0,
      65,    66,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    67,    87,   160,    88,    68,     0,    69,    70,
      71,    72,    73,    74,    75,    76,    77,     0,    78,     0,
      79,    80,    81,    82,    83,    84,    85,    86,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
       0,     0,     0,   312,     0,     0,     0,     0,     0,   313,
       0,    65,    66,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    67,    87,   225,    88,    68,     0,    69,
      70,    71,    72,    73,    74,    75,    76,    77,     0,    78,
       0,    79,    80,    81,    82,    83,    84,    85,    86,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,     0,   331,     0,     0,     0,     0,     0,
     332,     0,    65,    66,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    67,    87,   227,    88,    68,     0,
      69,    70,    71,    72,    73,    74,    75,    76,    77,     0,
      78,     0,    79,    80,    81,    82,    83,    84,    85,    86,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,     0,     0,     0,   335,     0,     0,     0,     0,
       0,   336,     0,    65,    66,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    67,    87,   267,    88,    68,
       0,    69,    70,    71,    72,    73,    74,    75,    76,    77,
       0,    78,     0,    79,    80,    81,    82,    83,    84,    85,
      86,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   262,     0,    65,    66,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    67,    87,   269,    88,
      68,     0,    69,    70,    71,    72,    73,    74,    75,    76,
      77,     0,    78,     0,    79,    80,    81,    82,    83,    84,
      85,    86,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   263,     0,    65,    66,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    67,    87,   295,
      88,    68,     0,    69,    70,    71,    72,    73,    74,    75,
      76,    77,     0,    78,     0,    79,    80,    81,    82,    83,
      84,    85,    86,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   302,     0,    65,    66,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    67,    87,
     296,    88,    68,     0,    69,    70,    71,    72,    73,    74,
      75,    76,    77,     0,    78,     0,    79,    80,    81,    82,
      83,    84,    85,    86,     0,   123,   124,     3,     4,     5,
       6,     7,     8,     9,    10,     0,     0,    67,     0,     0,
       0,    68,     0,    69,    70,    71,    72,    73,    74,    75,
       0,    77,     0,     0,     0,     0,     0,     0,     0,     0,
      87,     0,    88,   125,   126,   127,   128,   129,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,     0,   130,   311,
       0,     0,     0,     0,   131,   132,   223,   133,   134,   123,
     124,     3,     4,     5,     6,     7,     8,     9,    10,     0,
       0,    67,     0,     0,     0,    68,     0,    69,    70,    71,
      72,    73,    74,    75,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   125,   126,   127,
     128,   129,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,     0,   130,   316,     0,     0,     0,     0,   131,   132,
     180,   133,   134,   123,   124,     3,     4,     5,     6,     7,
       8,     9,    10,     0,     0,    67,     0,     0,     0,    68,
       0,    69,    70,    71,    72,    73,    74,    75,     0,    77,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   125,   126,   127,   128,   129,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,     0,   130,   344,     0,     0,
       0,     0,   131,   132,   188,   133,   134,   123,   124,     3,
       4,     5,     6,     7,     8,     9,    10,     0,     0,    67,
       0,     0,     0,    68,     0,    69,    70,    71,    72,    73,
      74,    75,     0,    77,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   125,   126,   127,   128,   129,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,     0,
     130,   348,     0,     0,     0,     0,   131,   132,     0,   133,
     134,   123,   292,     3,     4,     5,     6,     7,     8,     9,
      10,     0,     0,    67,     0,     0,     0,    68,     0,    69,
      70,    71,    72,    73,    74,    75,     0,    77,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   125,
     126,   127,   128,   129,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,     0,   130,   350,     0,     0,     0,     0,
     131,   132,     0,   133,   134,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   352,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     356,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   358,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   360,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   362,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   364,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     366,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     371,     0,   368,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,     0,   256,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,     0,     0,   314,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
       0,     0,   333,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,     0,     0,     0,   334,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,     0,   345,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,   279,     0,
     370,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211
};

static const short yycheck[] =
{
       0,   120,    53,     4,    57,    78,    79,    52,     0,    50,
      87,     0,    50,    50,    50,    51,    52,    53,    54,    19,
      76,    50,    74,    23,    73,   102,    26,    19,    80,    81,
      19,    23,    73,    77,    74,    73,    87,    73,    74,    79,
      81,    92,    42,    81,    81,    81,    91,    75,    80,    75,
      42,   102,    81,    53,    82,    55,    82,    73,   131,   132,
      60,    61,    55,    55,    57,    58,     3,     4,    60,    61,
      55,    96,    57,    58,   193,    76,    76,   122,    74,    74,
     105,    79,   107,    79,    76,    80,    79,    87,   139,    74,
      74,    74,    92,    79,    74,    79,   147,    80,    73,   176,
      80,   178,   102,    73,   155,   158,    50,    51,    52,    53,
      54,    53,    50,    51,    52,    53,    54,    74,   169,    55,
      74,    57,    58,    80,    73,   176,    80,   178,    73,    73,
      50,    51,    52,    53,    54,    73,    77,    81,    78,   139,
      80,   214,   215,    81,    73,    87,    73,   147,     3,     4,
      92,    68,    69,    70,   231,   155,   233,    73,     3,     4,
     102,     5,     6,     7,     8,     9,    10,    11,    12,   169,
      60,    61,   223,     6,     7,     8,   176,    10,   178,   230,
     231,   232,   233,   256,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,     3,     4,    73,   139,    73,    75,
      79,   252,    73,    77,    77,   147,   257,    53,   259,    30,
      79,    79,    79,   155,    73,    73,    82,   268,    82,   270,
      77,    77,    32,   223,    50,    77,    58,   169,    70,     4,
     230,   231,   232,   233,   176,    74,   178,    67,    68,    69,
      70,    87,     0,    19,    55,   284,    92,   109,   229,    -1,
      -1,    -1,   252,    74,    -1,    -1,   102,   257,    53,   259,
      -1,   312,    -1,   314,    -1,    -1,    -1,    -1,   268,    -1,
     270,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,   223,   333,   334,   335,    -1,    -1,    -1,   230,   231,
     232,   233,    87,   139,   345,    -1,    30,    92,    -1,    -1,
      -1,   147,    -1,    -1,    -1,    -1,    -1,   102,    -1,   155,
     252,    -1,   312,    -1,   314,   257,    -1,   259,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,   268,    -1,   270,    -1,
     176,    -1,   178,   333,   334,   335,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,   139,   345,    -1,    -1,    -1,    -1,
      -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,   314,    -1,   169,    -1,    -1,   223,    -1,    -1,
      -1,   176,    -1,   178,   230,   231,   232,   233,    -1,    -1,
      -1,   333,   334,   335,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   345,    -1,    -1,   252,    -1,    -1,    -1,
      -1,   257,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   268,    -1,   270,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    83,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,   252,    -1,    -1,
      -1,    -1,   257,    -1,   259,    -1,   312,   104,   314,    -1,
      -1,    -1,    30,   268,    -1,   270,    -1,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,    -1,   333,   334,   335,
      -1,    -1,    -1,   130,    -1,   132,    -1,    -1,   135,   345,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,   148,    -1,    -1,   151,   152,   153,   312,    -1,   314,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,   334,
     335,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
     345,    -1,    -1,    -1,    -1,   192,   193,   194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      82,    92,    -1,   240,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,   258,    -1,   260,    -1,   262,   263,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,   273,   274,   275,   276,
      -1,    -1,   279,    -1,    -1,   282,   283,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   147,   294,    -1,    -1,
      -1,    -1,    -1,    -1,   155,   302,    -1,    -1,    -1,    -1,
      -1,    -1,   309,   310,   311,    -1,   313,    -1,   169,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,   330,    -1,   332,    -1,    -1,    -1,   336,
      -1,    -1,    82,    -1,    -1,    -1,    -1,   344,    -1,    -1,
      -1,   348,    -1,   350,    -1,   352,    -1,   354,    -1,   356,
      -1,   358,    -1,   360,    -1,   362,    -1,   364,    -1,   366,
      -1,   368,   223,    -1,    -1,    -1,    -1,    -1,    -1,   230,
      -1,   232,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    -1,    -1,
      -1,   252,    -1,    80,    -1,    -1,   257,    -1,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,    -1,   270,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      -1,   312,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    57,    58,    -1,    -1,    -1,
      -1,    -1,   333,   334,   335,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   345,    77,    -1,    79,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    77,    78,    79,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    77,    78,    79,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    -1,
      33,    34,    35,    36,    37,    38,    39,    40,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    77,    78,    79,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    77,    78,    79,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    -1,    33,    34,    35,    36,    37,    38,    39,    40,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      -1,    80,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    77,    78,    79,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    77,    78,    79,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    -1,    33,    34,    35,    36,    37,    38,
      39,    40,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    77,    78,
      79,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    -1,    33,    34,    35,    36,    37,
      38,    39,    40,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    77,
      78,    79,    19,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    -1,    15,    -1,    -1,
      -1,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    79,    41,    42,    43,    44,    45,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    80,
      -1,    -1,    -1,    -1,    72,    73,    74,    75,    76,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      -1,    15,    -1,    -1,    -1,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    80,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    76,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    15,    -1,    -1,    -1,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    43,    44,    45,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    80,    -1,    -1,
      -1,    -1,    72,    73,    74,    75,    76,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    -1,    15,
      -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    80,    -1,    -1,    -1,    -1,    72,    73,    -1,    75,
      76,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    -1,    15,    -1,    -1,    -1,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    80,    -1,    -1,    -1,    -1,
      72,    73,    -1,    75,    76,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       0,    -1,    80,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    56,    -1,
      74,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 165 "parser.yxx"
{ParseTreePointer=yyvsp[0].m_pParseNode;}
    break;
case 2:
#line 167 "parser.yxx"
{ParseTreePointer->AddLastChild(yyvsp[0].m_pParseNode);}
    break;
case 5:
#line 177 "parser.yxx"
{
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-6].m_Identifier->c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;
case 6:
#line 190 "parser.yxx"
{
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-6].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-6].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-6].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;
case 7:
#line 206 "parser.yxx"
{
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-5].m_Identifier->c_str(), yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 8:
#line 213 "parser.yxx"
{
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-5].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-5].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-5].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 9:
#line 226 "parser.yxx"
{
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-5].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");
								
								// Make a string of the parameter types.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());
									while(pVar)
									{
										// If storage is not specified, a function parameter defaults to varying.
										pVar->SetDefaultStorage(Type_Varying);
										// Get the type from the variable
										strArgTypes+=CqParseNode::TypeIdentifier(pVar->ResType());
										// TODO: Find out if local function arguments can have default values.
										// If so, they can be found as the child of pVar.
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), strArgTypes.c_str(), yyvsp[-1].m_pParseNode, pArgs);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;
case 10:
#line 265 "parser.yxx"
{
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-4].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), "", yyvsp[-1].m_pParseNode, 0);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;
case 11:
#line 287 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;
case 12:
#line 295 "parser.yxx"
{	
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;
case 13:
#line 303 "parser.yxx"
{
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;
case 14:
#line 316 "parser.yxx"
{	
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;
case 15:
#line 332 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Lightsource;
							}
    break;
case 16:
#line 335 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Surface;
							}
    break;
case 17:
#line 338 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Volume;
							}
    break;
case 18:
#line 341 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Displacement;
							}
    break;
case 19:
#line 344 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Transformation;
							}
    break;
case 20:
#line 347 "parser.yxx"
{ 
								yyval.m_ShaderType = Type_Imager;
							}
    break;
case 21:
#line 354 "parser.yxx"
{
								// Create a list header, and add the first entry to it.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;
case 22:
#line 367 "parser.yxx"
{
								// Add this one to the list.
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;
case 24:
#line 382 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;
case 25:
#line 453 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNodeVariable* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetOutput();
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;
case 26:
#line 529 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
										{
											Type=(TqInt)(Type|Type_Array);
											if( pVar->ArrayLength() <= 0 )
												yyerror("Array length must be specified.");
										}

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;
case 27:
#line 604 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									SqVarRef varLocal, varExtern;
									TqBool fvl=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), varLocal);

									// As this is an extern, we need to repeatedly check in the previous namespaces
									// until we find the variable they are referring to.
									TqBool fve=TqFalse;
									if(!ParseNameSpaceStack.empty())
									{
										std::vector<CqString>::reverse_iterator i=ParseNameSpaceStack.rbegin()+1;
										while(!fve && i!=ParseNameSpaceStack.rend())
										{
											CqString strNS=*i;
											fve=CqVarDef::FindVariable((strNS+pDecl->strName()).c_str(), varExtern);
											i++;
										}
									}

									// If we found a candidate...
									if(fve && fvl)
									{
										CqVarDef* pvarLocal=CqVarDef::GetVariablePtr(varLocal);
										CqVarDef* pvarExtern=CqVarDef::GetVariablePtr(varExtern);
										CqParseNode* pVarNode=new CqParseNodeVariable(varLocal);
										pvarLocal->SetExtern(TqTrue, varExtern);
										pvarLocal->SetType(pvarExtern->Type());
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);
									}
									else
										yyerror("extern not found");

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;
case 28:
#line 649 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=(TqInt)(yyvsp[0].m_TypeAndSpace.Type|yyvsp[-1].m_VarType);
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_TypeAndSpace.Space;
							}
    break;
case 30:
#line 657 "parser.yxx"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 31:
#line 664 "parser.yxx"
{
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 32:
#line 671 "parser.yxx"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-1].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[-1].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 33:
#line 680 "parser.yxx"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[0].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;
case 34:
#line 687 "parser.yxx"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-3].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-3].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;
case 35:
#line 695 "parser.yxx"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-4].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-4].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 36:
#line 703 "parser.yxx"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-2].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-2].m_Identifier).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;
case 37:
#line 710 "parser.yxx"
{
								// Create a new declaration based on the name.
								// TODO: Should warn about duplicate declarations.
								CqString strName("");
								if(yyvsp[-1].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 38:
#line 724 "parser.yxx"
{
								CqString strName("");
								if(yyvsp[0].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[0].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[0].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;
case 39:
#line 734 "parser.yxx"
{
								CqString strName("");
								if(yyvsp[-3].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-3].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;
case 40:
#line 745 "parser.yxx"
{
								CqString strName("");
								if(yyvsp[-4].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-4].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-4].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 41:
#line 756 "parser.yxx"
{
								CqString strName("");
								if(yyvsp[-2].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-2].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;
case 42:
#line 769 "parser.yxx"
{
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;
							}
    break;
case 43:
#line 776 "parser.yxx"
{
								CqParseNode* pArrayInit=new CqParseNode();
								CqParseNode* pInit=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pInit)
								{
									CqParseNode* pInit2=pInit->pNext();
									pArrayInit->AddLastChild(pInit);
									pInit=pInit2;
								}
								yyval.m_pParseNode=pArrayInit;
							}
    break;
case 44:
#line 790 "parser.yxx"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 45:
#line 797 "parser.yxx"
{
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 46:
#line 804 "parser.yxx"
{	yyval.m_VarType=Type_Varying;	}
    break;
case 47:
#line 805 "parser.yxx"
{	yyval.m_VarType=Type_Uniform;	}
    break;
case 48:
#line 809 "parser.yxx"
{	
								yyval.m_TypeAndSpace.Type=Type_Float;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 49:
#line 813 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_String;	
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 50:
#line 817 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Void;
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 56:
#line 829 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;
case 57:
#line 833 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 58:
#line 840 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;
case 59:
#line 844 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 60:
#line 851 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;
case 61:
#line 855 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 62:
#line 862 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;
case 63:
#line 866 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 64:
#line 873 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;
case 65:
#line 877 "parser.yxx"
{
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;
case 67:
#line 888 "parser.yxx"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;
case 68:
#line 895 "parser.yxx"
{
								// Add this one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 69:
#line 902 "parser.yxx"
{yyval.m_pParseNode->NoDup();}
    break;
case 70:
#line 903 "parser.yxx"
{
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;
case 71:
#line 911 "parser.yxx"
{
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;
case 72:
#line 919 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeDrop();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 73:
#line 925 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								// Increment the count of returns for the current function.
								if(FunctionReturnCountStack.size() > 0)
									FunctionReturnCountStack.back()++;
							}
    break;
case 76:
#line 936 "parser.yxx"
{
								// Remove the variable nodes from these leaving just the 
								// intialisation code.
								// Each child of the variable_definitions is a CqParseNodeVariable
								CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(yyvsp[-1].m_pParseNode->pFirstChild());
								while(pVar)
								{
									CqParseNodeVariable* pTemp=static_cast<CqParseNodeVariable*>(pVar->pNext());

									// If storage is not specified, local variable defaults to varying.
									pVar->SetDefaultStorage(Type_Varying);
									
									// Relink the initialisers, if any, after the variable.
									if(pVar->pFirstChild())
									{
										// Make sure that any change in the storage type is communicated to the initialiser
										pVar->pFirstChild()->UpdateStorageStatus();
										CqParseNode* pVarying=pVar->pFirstChild();
										pVarying->LinkAfter(pVar);
									}
									pVar->UnLink();
									delete(pVar);
									pVar=pTemp;
								}
							}
    break;
case 78:
#line 962 "parser.yxx"
{	yyval.m_pParseNode=yyvsp[-1].m_pParseNode;	}
    break;
case 79:
#line 963 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNode(); }
    break;
case 80:
#line 964 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNode(); }
    break;
case 81:
#line 966 "parser.yxx"
{
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-1].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;
case 82:
#line 974 "parser.yxx"
{
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-3].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;
case 83:
#line 988 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 84:
#line 995 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(yyvsp[-4].m_pParseNode);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 85:
#line 1010 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeSolarConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 86:
#line 1016 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeSolarConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 87:
#line 1030 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 88:
#line 1039 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 89:
#line 1055 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 90:
#line 1068 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 91:
#line 1082 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 92:
#line 1099 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-8].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-8].m_pParseNode->NoDup();
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;
case 95:
#line 1124 "parser.yxx"
{	
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 96:
#line 1128 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 98:
#line 1138 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator.", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 99:
#line 1149 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 100:
#line 1160 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 101:
#line 1171 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator^", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 102:
#line 1182 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 103:
#line 1193 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 104:
#line 1204 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddFirstChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;
case 106:
#line 1215 "parser.yxx"
{
//								if($3->ResType() == $5->ResType())
//								{
									CqParseNode* pNew=new CqParseNodeQCond();
									pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
									pNew->AddLastChild(yyvsp[-4].m_pParseNode);
									pNew->AddLastChild(yyvsp[-2].m_pParseNode);
									pNew->AddLastChild(yyvsp[0].m_pParseNode);
									yyval.m_pParseNode=pNew;
//								}
//								else
//								{
//									yyerror("expressions don't match");
//									$$=new CqParseNode();
//								}
							}
    break;
case 107:
#line 1235 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pCast=new CqParseNodeCast(yyvsp[-1].m_TypeAndSpace.Type);
								pCast->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pCast->AddFirstChild(yyvsp[0].m_pParseNode);
								
								TqInt Type=(TqInt)(yyvsp[-1].m_TypeAndSpace.Type&Type_Mask);
								CqString* pSpace=yyvsp[-1].m_TypeAndSpace.Space;
								// Check if the type has a valid space associated
								if(pSpace!=0 && pSpace->compare("")!=0 && 
								  ((Type==Type_Point) ||
								   (Type==Type_Normal) ||
								   (Type==Type_Vector) ||
								   (Type==Type_Matrix) ||
								   (Type==Type_Color) ))
								{
									// Create a transform function.
									std::vector<SqFuncRef> funcTrans;
									CqString strTrans("transform");;
									if(Type==Type_Normal)	strTrans="ntransform";
									else if(Type==Type_Vector)	strTrans="vtransform";
									else if(Type==Type_Matrix)	strTrans="mtransform";
									else if(Type==Type_Color)	strTrans="ctransform";
									if(FindFunction(strTrans.c_str(), funcTrans))
									{
										yyval.m_pParseNode=new CqParseNodeFunctionCall(funcTrans);
										yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									
										// And create a holder for the arguments.
										CqParseNode* pFromSpace=new CqParseNodeStringConst((*yyvsp[-1].m_TypeAndSpace.Space).c_str());
										CqParseNode* pToSpace;
										if(Type != Type_Color)	pToSpace = new CqParseNodeStringConst("current");
										else					pToSpace = new CqParseNodeStringConst("rgb");
										yyval.m_pParseNode->AddLastChild(pFromSpace);
										yyval.m_pParseNode->AddLastChild(pToSpace);
										yyval.m_pParseNode->AddLastChild(pCast);
									}
								}
								else
									yyval.m_pParseNode->AddFirstChild(pCast);
							}
    break;
case 108:
#line 1281 "parser.yxx"
{	
								yyval.m_pParseNode=new CqParseNodeFloatConst(yyvsp[0].m_FloatConst);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 110:
#line 1286 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 111:
#line 1290 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[-3].m_pSymbol.VarRef);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 112:
#line 1295 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 117:
#line 1303 "parser.yxx"
{	
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;
case 118:
#line 1307 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeTriple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 119:
#line 1315 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeHexTuple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-31].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-29].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-27].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-25].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-23].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-21].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-19].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-17].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-15].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-13].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-11].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-9].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-7].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 120:
#line 1338 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_G);	}
    break;
case 121:
#line 1339 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_GE);	}
    break;
case 122:
#line 1340 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_L);	}
    break;
case 123:
#line 1341 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_LE);	}
    break;
case 124:
#line 1342 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_EQ);	}
    break;
case 125:
#line 1343 "parser.yxx"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_NE);	}
    break;
case 126:
#line 1347 "parser.yxx"
{
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;
case 127:
#line 1351 "parser.yxx"
{
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;
case 128:
#line 1358 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogAnd);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 129:
#line 1365 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogOr);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 130:
#line 1371 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeUnaryOp(Op_LogicalNot);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 131:
#line 1380 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 132:
#line 1386 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;
case 133:
#line 1400 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;
case 134:
#line 1414 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;
case 135:
#line 1428 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;
case 136:
#line 1442 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;
case 137:
#line 1449 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;
case 138:
#line 1467 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;
case 139:
#line 1485 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;
case 140:
#line 1503 "parser.yxx"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;
case 141:
#line 1524 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pFunc;
							}
    break;
case 142:
#line 1533 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pFunc;
							}
    break;
case 143:
#line 1545 "parser.yxx"
{
								std::cerr << warning << "Hit unresolved call to function: " << yyvsp[-3].m_Identifier->c_str() << 
														"We will attempt to resolve this with a DSO at runtime" << std::endl;
								CqParseNode* pArgs=yyvsp[-1].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									CqParseNode* pArg=static_cast<CqParseNode*>(pArgs->pFirstChild());
									while(pArg)
									{
										strArgTypes+=CqParseNode::TypeIdentifier(pArg->ResType());
										pArg=static_cast<CqParseNode*>(pArg->pNext());
									}
								};

								CqFuncDef func_spec(Type_Nil,yyvsp[-3].m_Identifier->c_str(),"unresolved",strArgTypes.c_str(), (CqParseNode*)NULL, pArgs);
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pUFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pUFunc;
							}
    break;
case 144:
#line 1568 "parser.yxx"
{
								// Need to emit a warning.
								// This should in theory be the eaiest case to handle
								// since there are no arguments that might need casting
								// later.
								std::cerr << warning << "Hit unresolved call to function: " << yyvsp[-2].m_Identifier->c_str() << 
														"We will attempt to resolve this with a DSO at runtime" << std::endl;
								CqFuncDef func_spec(Type_Nil, yyvsp[-2].m_Identifier->c_str(), "unresolved","");
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pUFunc;
							}
    break;
case 145:
#line 1584 "parser.yxx"
{
								// Create a list header, and add the first entry.
									yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 146:
#line 1591 "parser.yxx"
{
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 147:
#line 1599 "parser.yxx"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;
case 148:
#line 1613 "parser.yxx"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;
case 149:
#line 1627 "parser.yxx"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;
case 150:
#line 1633 "parser.yxx"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
							}
    break;
case 151:
#line 1641 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("texture", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 152:
#line 1647 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("environment", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 153:
#line 1653 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("bump", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 154:
#line 1659 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("shadow", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 155:
#line 1665 "parser.yxx"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("occlusion", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 156:
#line 1674 "parser.yxx"
{	
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 157:
#line 1678 "parser.yxx"
{	
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;
case 158:
#line 1685 "parser.yxx"
{	yyval.m_pParseNode=yyvsp[-1].m_pParseNode; }
    break;
case 159:
#line 1689 "parser.yxx"
{
								// Create a list header and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;
case 160:
#line 1696 "parser.yxx"
{
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;
case 162:
#line 1709 "parser.yxx"
{yyval.m_CommType=CommTypeAtmosphere;}
    break;
case 163:
#line 1710 "parser.yxx"
{yyval.m_CommType=CommTypeDisplacement;}
    break;
case 164:
#line 1711 "parser.yxx"
{yyval.m_CommType=CommTypeLightsource;}
    break;
case 165:
#line 1712 "parser.yxx"
{yyval.m_CommType=CommTypeSurface;}
    break;
case 166:
#line 1713 "parser.yxx"
{yyval.m_CommType=CommTypeAttribute;}
    break;
case 167:
#line 1714 "parser.yxx"
{yyval.m_CommType=CommTypeOption;}
    break;
case 168:
#line 1715 "parser.yxx"
{yyval.m_CommType=CommTypeRendererInfo;}
    break;
case 169:
#line 1716 "parser.yxx"
{yyval.m_CommType=CommTypeIncident;}
    break;
case 170:
#line 1717 "parser.yxx"
{yyval.m_CommType=CommTypeOpposite;}
    break;
case 171:
#line 1718 "parser.yxx"
{yyval.m_CommType=CommTypeTextureInfo;}
    break;
case 172:
#line 1724 "parser.yxx"
{
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;
case 173:
#line 1746 "parser.yxx"
{
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1777 "parser.yxx"


namespace Aqsis
{

TqBool FindVariable(const char* name, SqVarRef& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalVar(strNameSpace()+name);
	
	if(CqVarDef::FindVariable(strLocalVar.c_str(), Ref))	return(TqTrue);
	else	return(CqVarDef::FindVariable(name, Ref));

	
}


TqBool FindFunction(const char* name, std::vector<SqFuncRef>& Ref)
{
	// Search in the namespaces from local to global in order.
	CqString strNS(strNameSpace());
	
	do
	{
		CqString strLocalFunc(strNS+name);
		if(CqFuncDef::FindFunction(strLocalFunc.c_str(), Ref))
			return(TqTrue);

		// Extract the next namespace up.
		if( ( strNS.size() > 2 ) && ( strNS.substr( strNS.size()-2 ) == "::" ) )
		{
			strNS = strNS.substr( 0, strNS.size()-2 );
			strNS = strNS.substr(0, strNS.rfind("::")+strlen("::"));
		}

	}while( strNS.find_last_of("::") != std::string::npos );
	
	return(CqFuncDef::FindFunction(name, Ref));
}


void TypeCheck()
{
	// Typecheck any declared variables.
	TqUint i;
	for(i=0; i<gLocalVars.size(); i++)
	{
		if(gLocalVars[i].pDefValue()!=0)
			gLocalVars[i].pDefValue()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
	}

	// Typecheck any local functions.
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
		{
//			TqInt RetType=gLocalFuncs[i].Type();
			gLocalFuncs[i].pDefNode()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
		}
	}

	if(ParseTreePointer)
		ParseTreePointer->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
}


void Optimise()
{
	// Optimise any local functions.
	TqUint i;
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
			gLocalFuncs[i].pDefNode()->Optimise();
	}

	if(ParseTreePointer)
		ParseTreePointer->Optimise();
}


CqString strNameSpace()	
{
	CqString strRes("");

	if(!ParseNameSpaceStack.empty())
		strRes=ParseNameSpaceStack.back();

	return(strRes);
}

void InitStandardNamespace()
{
	ParseNameSpaceStack.push_back("");
}

void ProcessShaderArguments( CqParseNode* pArgs )
{
	if(pArgs)
	{
		// Each child of the variable_definitions is a CqParseNodeVariable
		CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());

		while(pVar)
		{
			// If storage is not specified, a shader parameter defaults to uniform.
			pVar->SetDefaultStorage(Type_Uniform);
			// Force the variable to be a parameter.
			pVar->SetParam();

			// Check if a default value has been specified.
			CqParseNode* pDefValue=pVar->pFirstChild();
			if(pDefValue!=0)
			{
				// Get a pointer to the local variable.
				CqVarDef* pVarDef=CqVarDef::GetVariablePtr(pVar->VarRef());
				if(pVarDef!=0)
				{
					CqParseNode Node;
					pDefValue->UnLink();
					CqParseNodeCast* pCast=new CqParseNodeCast(pVarDef->Type());
					Node.AddLastChild(pCast);
					pCast->AddLastChild(pDefValue);
					Node.Optimise();
					pVarDef->SetpDefValue(Node.pFirstChild());
					pVar->AddFirstChild( Node.pFirstChild() );
				}
			}
			pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
		}
	}
}


} // End Namespace

static void yyerror(const CqString Message)
{
	ParseSucceeded = false;
	//(*ParseErrorStream) << "libslparse > parser > error: " << Message.c_str() << " at " << ParseStreamName.c_str() << " line " << ParseLineNumber << std::endl;
	CqString strErr( ParseStreamName.c_str() );
	strErr += " : ";
	strErr += ParseLineNumber;
	strErr += " : ";
	strErr += Message.c_str();
	throw( strErr );
}
